// Copyright (c) 2009, Matej Cepl mcepl at redhat dot com
// Released under the MIT/X11 license
// http://www.opensource.org/licenses/mit-license.php

// ==UserScript==
// @name           Add Bugzapper's signature
// @namespace      http://www.ceplovi.cz/matej/progs/scripts
// @description    adds a signature indicating that an author of the comment is an bugzapper.
// @include        https://bugzilla.redhat.com/show_bug.cgi?id=*
// @include        https://bugzilla.redhat.com/process_bug.cgi
// ==/UserScript==
// TODO:
//   * make UI for switching addSignatureYN

var signatureString = "\n\n-- \n"+
"Fedora Bugzappers volunteer triage team\n"+
"https://fedoraproject.org/wiki/BugZappers";
var promptString = "Do you want to have signature indicating that you are\n"+
"a bugzapper added to every comment? (Yes/No)";

/** Clean the string from spaces around
*
* @param string to be cleaned
* @return string which was cleaned
*
*/
function strip(str) {
   return str.replace(/^\s*(.*)\s*$/,"$1");
}

/** add Fedora Bug zapper's signature to the comment of the current bug
 */
function addSignature(evt) {
	var commentText = document.getElementById("comment");
	if (strip(commentText.value).length > 0) {
		commentText.value = strip(commentText.value) + signatureString;
	}
}

/** set style of the element according to the status of signatures being
  * on or off
  */
function setStyleSignatureStatus (element) {
   if (addSignatureYN == 1) {
      element.style.textDecoration = "none";
      element.style.color = "inherit";
      element.style.backgroundColor = "#CCFF99";
   } else {
      element.style.textDecoration = "line-through";
      element.style.color = "grey";
      element.style.backgroundColor = "#FFCCFF";
   }
}

/* callback function to flip the state of the adding signatures.
 */
function setSignatureStatusCB(evt) {
   if (addSignatureYN == 1) {
      addSignatureYN = 0;
   } else {
      addSignatureYN = 1;
   }
   GM_setValue("makeSignature",addSignatureYN);
}

function addSignatureButtonSwitch () {
   var bugzillaBodyULs =
      document.getElementById("bugzilla-body").getElementsByTagName("ul");
   var relatedActionsList = null;
   var ul = null;

   for (var ulIndex in bugzillaBodyULs) {
      ul = bugzillaBodyULs[ulIndex];
      if (ul.className.search(/related_actions/) != -1) {
         relatedActionsList = ul;
         break;
      }
   }
   if (relatedActionsList) {
      var newElement = document.createElement("li");
      newElement.appendChild(document.createTextNode(" - "));
      var newAElem = document.createElement("a");
      newElement.appendChild(newAElem);
      newAElem.appendChild(document.createTextNode("Signature"));
      newAElem.setAttribute("href","");
   	newAElem.addEventListener('click',
   		function(event) {setSignatureStatusCB();},
   	   	false);
      relatedActionsList.appendChild(newElement);
	   setStyleSignatureStatus(newAElem);
   }
}

var statusElement = null;
var addSignatureYN = Number(GM_getValue("makeSignature","NA"));
if (isNaN(addSignatureYN)) {
	var replyString = prompt(promptString, "No").toLowerCase();
	if ((replyString == "yes") || (replyString == "y")) {
		addSignatureYN = 1;
	} else {
		addSignatureYN = 0;
	}
	GM_setValue("makeSignature",addSignatureYN);
}

addSignatureButtonSwitch();

if (addSignatureYN == 1) {
   // (or a form named "changeform")
   document.forms[1].addEventListener("submit",addSignature,true);
}